/**
 *　Dragunova.js /ドラグノフJS
 * 2chのレスを編集可能にするJS
 * @author TouyouHacker (東洋黒客 twitter:@touyou_hk)
 * @author General BlackBunny (ジェネラル・黒うさぎ twitter:@GeneralBBunny)
 * 
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * Copyright ©2012 GeneralBlackBunny. All Rights Reserved
 * https://sourceforge.jp/projects/j2chmatometter/
 */

var copyResCounter = 0;

$(function() {
	
	// スレ読み込みボタンイベント登録
	$("#threadReadButton").click(
			function(){
				readTreadToIframe();
			});
	
	// HTML書き出しボタン登録
	$("#writeEditedHtml").click(
			function(){
				writeHtmlTo();
			});
	
	// デバッグ用-スレHTMLを編集可能とする
	$("#editAbleHtml").click(
			function(){
				editAble();
			});
	
	$("#threadReadButton").button();
	$("#writeEditedHtml").button();
	$("#moveDetailEdit").button();
	
	// プラグイン用チェックボックスのイベント登録
	pluginCheckBoxAllOnload();
	
	//　プラグイン実行ボタンへのイベント登録
	$("#plugInExecute").click(
			function() {
				var $htmlObj = $("#editFrame");
				pluginExecuter($htmlObj);
				
			}
			);
});

/**
 * AJAX通信でスレを取得する
 * AJAXはクロスドメイン通信ができないためローカルサーバーに2ch通信させてスレを取得させる
 * CliantJS → [AJAX]-LocalServer → [HTTP]-2ch
 * 
 * ローカルサーバーはプロクシでも代用可(単純にスレHTMLを取得するだけなら・・dat取得等は考慮が必要)
 * ローカルサーバーAPロジックは何でも可能 (Tomcat/JSP,Apache-Perl/PHP/Ruby)
 */
function readTreadToIframe(){
	if(urlValidater() === false){
		return;
	}
	
	//ex:http://localhost:8080/2chMtMt4Jsp/GetWebContentsServlet?url=http://kilauea.bbspink.com/test/read.cgi/hgame2/1333342832/
	var getApName = "GetWebContentsServlet";
	var baseUrl= getApName + "?url=";
	var reqUrl= $("#threadUrl").val();
	
	var getUrl = baseUrl + reqUrl;

	var param2 = "&encode=";
	
	// 読み込んだHTMLから読み込み開始するセレクタの設定
	// 2chのデフォ
	var readStartSelecter = ".thread";
	
	// ホストのジャッジ
	var judgeResult = dragunovaUtil_judgeBordHost(getUrl);
	if (DRAGUNOVA.bordListName.sitaraba === judgeResult) {
		
		// したらば掲示板の場合
		readStartSelecter = "#thread-body";
		
		// エンコードを指定する
		getUrl = getUrl + param2 + "euc-jp";
		
	}
	
	// IE8というかIE? での.loadバグ
	// http://stackoverflow.com/questions/7213980/jquery-load-method-not-working-ie8
//	if($.browser.msie) {
//		getUrl = getUrl + Math.random()*99999 ;
//	}
	
	
	if($.browser.msie) {
		$.ajaxSetup({ cache: false });
		$.ajax({
			url: getApName,
			dataType: "html",
			cache: false,
			data: {"url":reqUrl},
			success: function(data){
				alert(data);
			var $orignHtml = $(data);	
			 $("#threadFrame").html( $orignHtml.find(readStartSelecter).html() );	
			}
		});
		
		return;
	}
	
	
		 $("#threadFrame").load(getUrl + " " + readStartSelecter,
			function(data) {
			 	editAble();
//			 	if($.browser.msie) {
//			 		data.preventDefault();
//			 	}
		 	});
	/*
	 * $.get( getUrl, function (data) { alert(data);
	 * $("#threadFrame").html(data); } );
	 */
	
}

function writeHtmlTo() {
	$("#copyHtmlFrame").html($("#editFrame").html());
}

/**
 * URLの正当性をチェックする関数
 * 2ch系以外のURLをiframeに読み込ませない
 */
function urlValidater() {
	
	// チェックにひかかったらアラート
	if ($("#threadUrl").val() === "") {
		common_alert("", "読み込みURLが指定されていません。");
		return false;
	}
}

//スレを編集可能にする(DEBUG)
// 編集後のレス削除、レス順の入れ替え可能にする,フォントサイズと色変えの機能は必須
// レスのオートトレースオプション機能も必要(レス内にアンカーがあったらそのレスもコピーする)
// 名前をかえる機能（一括置換)
// 2chブラウザみたいに　レスをもらってるレスとIDごとの投稿数の表示
function editAble () {
	// スレッドのdt dd要素をひとまとめにする
	$("#editFrame").html("");
	copyResCounter = 0;
	$("#copyCounter").text(copyResCounter);
	
	$("#threadFrame").contents().find("dd").addClass("copy");
	
	$('.copy').mouseenter(
			function(){
				if ($(this).data(".copyed") === "1"){
					return;
				} 
				
				$(this).changeResBgColor("#ff9999");
	});
	
	$('.copy').mouseleave(
			function(){
				if ($(this).data(".copyed") === "1"){
					return;
				} 				
				$(this).changeResBgColor("#ffffff");
	});
	
	$('.copy').dblclick(
			function(){
				if ($(this).data(".copyed") === "1"){
					return;
				} 
				
				copyResCounter++;
				
				$("#editFrame").append("<dt>" +  $(this).prev().html() + "</dt>");
				$("#editFrame").append("<dd>" +  $(this).html() + "</dd>");
				
				$("#copyCounter").text(copyResCounter);
				
				// レスグループの背景色変更
				$(this).changeResBgColor("silver");
				
				$(this).data(".copyed","1");
			});
	

	
	/*
	// dtddにドラッククラスを付与する
	// class=draggable
	$("#threadFrame").contents().find("dt,dd").addClass("draggable");
	$(".draggable").draggable();
	
	// エディットDIVをドラッグ可能領域に設定する
	$("#editFrame").addClass("droppable");
	$('.droppable').droppable({
		accept: '.draggable',
		drop: function (e, ui){		
		}
	});
	*/
}



function moveDetailEdit() {
	writeHtmlTo();
	$("#copyHtmlSubmit").click();
}


function pluginCheckBoxAllOnload(){
	var all = $('#pluginAll');
	var checkboxs = $('p.pluginCheckBoxs input');
	
	all.click(function() {
		if(this.checked){
			checkboxs.attr('checked', 'checked');
		} else {
			checkboxs.removeAttr('checked');
		}
	});
}

/* TODO 処理中がわかるダイアログかローディング画面が必要
 * 各プラグインの処理中がわかるメッセージが必要
*/
/**
 * プラグインを実行します
 * @param $htmlObj jQuery HTMLオブジェクト
 */
function pluginExecuter($htmlObj){
 	
	// TODO 各プラグインの実行順序が変更されても正常に動作するよう注意する
	// プラグインのほうで処理矛盾が起こらないように注意する必要がある
	
	// TODO プラグイン実行後、操作を取り消したい場合、取り消しができるボタンが必要
	
	// TODO プラグインの総合処理時間は画面に出せるようにする
	
 	if($("#imeNuLinkDelete").judgeCheckBox()){
 		$htmlObj.imeNuLinkDelete();
 	}
 	
 	if($("#pinkTowerLinkDelete").judgeCheckBox()){
 		$htmlObj.pinkTowerLinkDelete();
 	}
 	
 	if($("#beLinkImageDelete").judgeCheckBox()){
 		$htmlObj.beLinkImageDelete();
 	}
 	
 	if($("#nameLessAllChange").judgeCheckBox()){
 		// 変更したい名前を取得
 		var changedName = $("#nameLessChangeText").val();
 		$htmlObj.nameLessAllChange(changedName);
 	}
 	
 	if($("#mailDelete").judgeCheckBox()){
 		jQuery.fn.mailDelete.color = "green";
 		$htmlObj.mailDelete();
 	}
 	
 	if($("#hyperLinkRecover").judgeCheckBox()){
 		$htmlObj.hyperLinkRecover();
 	}
 	

 	
}


/**
* 指定されたチェックボックスの状態を判定します 
* チェックされていたらtrue,されてないならfalaseを返却します
* 
* @selecter チェックボックス
* @return true:チェックされている false:チェックされていない
*/
jQuery.fn.judgeCheckBox = function () {
	if ('checked' === jQuery(this).attr('checked')){
		return true;
	}
	return false;
};