/*
 * jquery.zweiChThredView.js
 * 2ch-HTMLをスレッドビューワーとして見やすく加工するメソッド群
 * 
 * Jsライブラリのため2ch(HTML版)をターゲットとしています
 * 2ch(DAT版)はターゲットとしてないのでDATをHTMLに変換して当ライブラリを使用してください。
 * 当ライブラリは「2chMatometter」という2chまとめ作成ソフトから
 * 汎用的に使用できるメソッドを切り出したものになります。
 * https://sourceforge.jp/projects/j2chmatometter/
 * 
 * Ver 0.1
 * @author General BlackBunny (ジェネラル・黒うさぎ twitter:@GeneralBBunny)
 * 
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * Copyright ©2012 GeneralBlackBunny. All Rights Reserved
 */

/**
 * 2ch-HTMLのレスにデータ処理用の番号をjQueryのdataメソッドで紐付けします
 * 		レスの番号でなくHTMLのddの順番を設定します。
 * @selecter 2ch-HTML
 */
jQuery.fn.setResDataNum = function() {
	// レスの順番
	var num = 1;
	var $targets = jQuery(this).find("dd");
	$targets.each(function() {
		$(this).data("resDNum",num);
		num++;
	});
	
	return this;
};

